; Universal Thermostat ver. 1.10 / 2. 12. 2000
; Copyright  (c) 2000, Pavel Kaspar
;
                NAME	UT
MainVer         EQU     1            ; Cislo verze programu
SubVer          EQU     1            ; Podverze programu

PCON		EQU	087h	     ; Tato verze ASM51 nezna PCON

BR9600          EQU     0FDh

InvalTMP        EQU     03Fh         ; Konstanta pro neplatnou teplotu

; ****************************************************** Mapa pameti Procesoru

                DSEG

                ORG     0010h       ; RB0 - pracovni, RB1 - rezerva pro INT

; Teploty jsou obecne reprezentovany v setinach stupne s posunutou nulou 
; Nula znamena teplotu -50 stupnu, lze prezentovat rozsah -50,00 .. +111,00
; Hodnoty na +111,00 jsou "reserved", napr. pro hodnotu InvalTMP

TempH:          DS      1           ; Aktualni teplota v setinach stupnu v HEX
TempL:          DS      1           ; Teploty se lisi pro vytvoreni hystereze
Re1MaxH:        DS      1           ; Teplota,pri jejimz prekroceni vypne Re1
Re1MaxL:        DS      1
Re1MinH:        DS      1           ; Teplota,pri jejimz "podteceni" sepne Re1
Re1MinL:        DS      1 
Re2MaxH:        DS      1           ; Teplota,pri jejimz prekroceni vypne Re2
Re2MaxL:        DS      1
Re2MinH:        DS      1           ; Teplota,pri jejimz "podteceni" sepne Re2
Re2MinL:        DS      1

FunkceRe1:      DS      1           ; Meni funkci Re1,tj. misto Topi na Chladi
FunkceRe2:      DS      1           ; Chlazeni misto vypnuti zapne a opacne

ReStatus:       DS      1           ; Stav Rele (bit 0 a 1)

KBD:            DS      1           ; Stav Klavesnice
KBDPom:         DS      1           ; Pomocny predchozi stav
LEDBuff:        DS      1           ; Buffer pro samostatne LED (bity 2.-0.)
DispBuff:       DS      4           ; Buffer pro zobrazeni na LED displ.
                                    ; 1. Byte = X... = nejvyssi rad
                                    ; 4. Byte = ...X = nejnizsi rad
PomBuff:        DS      4           ; Pomocny Buffer pro konverzi segmentu

                ORG     0060h       ; Pocatek zasobniku
Stack:          DS      0020h       ; Max. hloubka vnoreni

                CSEG

                ORG     0000h
PowerOn:        CLR     A
                SJMP    On_Reset

                ORG     0003h
ExtInt0:	RETI

                ORG     000Bh
Timer0Int:      RETI

                ORG     0013h
ExtInt1:        RETI

                ORG     001Bh
Timer1Int:      RETI

                ORG     0023h
SerialInt:      RETI

                ORG     002Bh
Timer2Int:      RETI


                ORG     0030h

On_Reset:       MOV	SP, #(Stack-1)	; Inicializace zasobniku
                MOV     PSW, A          ; Banka 0, v A je 0
                MOV     ReStatus, A
                MOV     SCON, #01010011b; Mod 1; 1 start,8 datovych,1 stop bit
		MOV	TMOD, #00100001b; C/T0 - mod 1, casovac 16 bitu
					; C/T1 - mod 2, casovac pro Serial
                MOV     TH1, #BR9600    ; Prenosova rychlost
                MOV     TL1, #BR9600
                MOV     PCON, #00000000b; Nasobitel SMOD = 0
		MOV	TCON, #01010101b; C/T0,1 povolen; EI0,1 reag. na hranu
                SETB    TI              ; Pro vyslani 1. znaku, jinak DeadLock
                CLR     RI              ;
		MOV	IE, #00000010b	; Disable, pripraveno pro T0
		MOV	IP, #00000000b  ; vse nizkou prioritu

                ACALL   InitLED         ; Inicializace = ClrLED
                ACALL   ZobrVer         ; Vypsani verze programu

                ACALL   Start_Conv      ; Prvni Konverze
                ACALL   UrciLimity      ; Naplni promenne limitnimi teplotami

                ACALL   CekejKonv       ; Cekani na dokonceni konverze
                                        ; a na zobrazeni verze programu
                ACALL   ZmerTeplotu     ; Zmeri teplotu a pripadne sepne Rele 

                MOV     LEDBuff, #05    ; Rozsvit LED c. 1 a 3
                MOV     A, FunkceRe1    ; Zobraz teplotu sepnuti Re1
                JNZ     Re1Chladi
                MOV     DPH, Re1MinH    ; Topi -> Zobraz Minimalni teplotu
                MOV     DPL, Re1MinL
                SJMP    ZobrLim1
Re1Chladi:      MOV     DPH, Re1MaxH    ; Chladi -> Zobraz Maximalni teplotu
                MOV     DPL, Re1MaxL
ZobrLim1:       ACALL   ZobrTDPTR

                ACALL   CekejKonv       ; Cekani na dokonceni konverze
                                        ; a na zobrazeni limitni teploty Re1
                ACALL   ZmerTeplotu     ; Zmeri teplotu a pripadne sepne Rele

                MOV     LEDBuff, #06    ; Rozsvit LED c. 2 a 3
                MOV     A, FunkceRe2    ; Zobraz teplotu sepnuti Re2
                JNZ     Re2Chladi
                MOV     DPH, Re2MinH    ; Topi -> Zobraz Minimalni teplotu
                MOV     DPL, Re2MinL
                SJMP    ZobrLim2
Re2Chladi:      MOV     DPH, Re2MaxH    ; Chladi -> Zobraz Maximalni teplotu
                MOV     DPL, Re2MaxL
ZobrLim2:       ACALL   ZobrTDPTR

                MOV     LEDBuff, #00    ; Vynuluj buffer LED

                ACALL   CekejKonv       ; Cekani na dokonceni konverze
                                        ; a na zobrazeni limitni teploty Re2

; -------------------------------------------------------------- Hlavni smycka
Main:
                ACALL   ZmerTeplotu     ; Zmeri teplotu a pripadne sepne Rele
                ACALL   TestKBD         ; Otestuje klavesnici
                ACALL   ZobrTMP         ; Zobrazi aktualni teplotu
                ACALL   CekejKonv       ; Cekani na dokonceni konverze

                SJMP    Main

; ****************************************************************************

ZmerTeplotu:                            ; Zmeri teplotu a pripadne sepne Rele
                MOV     TempH, #InvalTMP; Pro pripad nepritomnosti cidla
                ACALL   ReadTMP         ; Nacte teplotu do TempH,L
                ACALL   CompTMP         ; Provna teploty Min a Max, provede
                                        ; i update stavu Rele a OPTO vstupu
                AJMP    Start_Conv      ; Nova konverze

UrciLimity:                             ; Naplni promenne Re1Max a Re2Min
                MOV     DPTR, #MaxTEMP1 ; Maximalni teplota pro Re1
                ACALL   PrevedHEX
                MOV     Re1MaxH, R2
                MOV     Re1MaxL, R3
                MOV     DPTR, #MinTEMP1 ; Minimalni teplota pro Re1
                ACALL   PrevedHEX
                MOV     Re1MinH, R2
                MOV     Re1MinL, R3

                MOV     FunkceRe1, #00h ; 00h = Topi - Default
                MOV     DPTR, #FceRe1
                CLR     A
                MOVC    A, @A+DPTR
                CJNE    A, #'C', UrciLim2
                MOV     FunkceRe1, #01h ; 01h = Chladi

UrciLim2:
                MOV     DPTR, #MaxTEMP2 ; Maximalni teplota pro Re2
                ACALL   PrevedHEX
                MOV     Re2MaxH, R2
                MOV     Re2MaxL, R3
                MOV     DPTR, #MinTEMP2 ; Minimalni teplota pro Re2
                ACALL   PrevedHEX
                MOV     Re2MinH, R2
                MOV     Re2MinL, R3

                MOV     FunkceRe2, #00h ; 00h = Topi - Default
                MOV     DPTR, #FceRe2
                CLR     A
                MOVC    A, @A+DPTR
                CJNE    A, #'C', UrciLim3
                MOV     FunkceRe2, #02h ; 02h = Chladi

UrciLim3:
                RET

; ============================================================================

ZobrTMP:                                ; Zobrazi teplotu na adrese TempH,L
                PUSH    DPL
                PUSH    DPH
                MOV     DPH, TempH
                MOV     DPL, TempL
                SJMP    ZobrTmp0

ZobrTDPTR:                              ; Zobrazi teplotu v DPTR
                PUSH    DPL
                PUSH    DPH
ZobrTmp0:
                PUSH    B
                MOV     A, DPH
                ANL     A, #3Fh         ; Orizni horni 2 neplatne bity
                MOV     DPH, A
                CJNE    A, #InvalTMP, ZobrTmp1 ; Test neplatne teploty
                MOV     A, #40h         ; Inval Str
                MOV     DispBuff+0, A
                MOV     DispBuff+1, A
                MOV     DispBuff+2, A
                MOV     DispBuff+3, A
                AJMP    ZobrTmpE
ZobrTmp1:
                ACALL   DPdiv10         ; Setiny v BCD
                MOV     R7, A           ; Zbytek z Setin
                ACALL   DPdiv10         ; Desetiny v BCD
                SWAP    A
                ADD     A, R7
                MOV     R7, A           ; Zbytek z Desetin a Setin

                ACALL   DPdiv10         ; Jednotky v BCD
                MOV     R6, A           ; Zbytek z Jednotek
                ACALL   DPdiv10         ; Desitky v BCD
                SWAP    A
                ADD     A, R6
                MOV     R6, A           ; Zbytek z Desitek a Jednotek

                ACALL   DPdiv10         ; Stovky v BCD
                MOV     B, A            ; Zbytek ze Stovek

                MOV     A, R6
                SUBB    A, #50h         ; Korekce Posunute nuly
                JNC     ZobrTmp2
                DEC     B               ; Prenos -> sniz Stovky
                SUBB    A, #5Fh         ; Proved dekadickou korekci, ! C = 1
ZobrTmp2:
                MOV     R6, A           ; V R5 bud 1, 0 nebo FFh pro zaporne

                MOV     A, B
                CJNE    A, #1, ZobrTmp3 ; 1 = Teplota pres 100 stupnu

                MOV     A, R6           ; Stupne a desitky stupnu
                ANL     A, #0F0h        ; Potrebuji jen desitky stupnu
                ADD     A, #01h         ; Pricti 1 = stovka stupnu
                SWAP    A
                ACALL   ZobrAH          ; Zobrazi stovku a desitky stupnu

                MOV     A, R6           ; Stupne a desitky stupnu
                ANL     A, #00Fh        ; Nyni potrebuji jen jednotky stupnu
                MOV     B, A
                MOV     A, R7           ; Desetiny a setiny stupne
                ANL     A, #0F0h        ; Potrebuji jen desetiny stupne
                ADD     A, B
                SWAP    A
                ACALL   ZobrAL          ; Zobrazi stupne a desetiny stupne
                ORL     DispBuff+2, #80h; Desetinna tecka
                SJMP    ZobrTmpE

ZobrTmp3:       JZ      ZobrTmpP        ; 0 = Kladna Teplota
                                        ; Vse ostatni = Pod nulou
                CLR     C               ; Vypocet Absolutni hodnoty
                MOV     A, #99h         ; Spravne se ma odecitat od 10000, ale
                SUBB    A, R7           ; u 9999 - R6/7 + 1 nedojde k prenosu
                ADD     A, #1
                DA      A
                MOV     R7, A
                PUSH    PSW             ; Uschovej si Carry

                CLR     C               ; Vynuluj Carry
                MOV     A, #99h
                SUBB    A, R6
                POP     PSW             ; Obnov Carry
                ADDC    A, #0           ; a pricti ho
                DA      A
                MOV     R6, A

                MOV     A, R6           ; Stupne a desitky stupnu
                ANL     A, #0F0h        ; Test nevyznamne nuly
                JNZ     ZobrTmpM

                MOV     A, R6           ; Nevyznamna nula
                ACALL   ZobrAH          ; Zobrazi stupne, desitky = 0
                MOV     DispBuff+0, #40h; Zobrazi minus
                MOV     A, R7
                ACALL   ZobrAL          ; Zobrazi desetiny a setiny stupne
                ORL     DispBuff+1, #80h; Desetinna tecka
                SJMP    ZobrTmpE

ZobrTmpM:                               ; Zaporna teplota s vyznamnou nulou
                MOV     A, R6           ; Stupne a desitky stupnu
                ANL     A, #0F0h        ; Potrebuji jen desitky stupnu
                SWAP    A
                ACALL   ZobrAH          ; Zobrazi desitky stupnu
                MOV     DispBuff+0, #40h; Zobrazi minus

                MOV     A, R6           ; Stupne a desitky stupnu
                ANL     A, #00Fh        ; Nyni potrebuji jen jednotky stupnu
                MOV     B, A
                MOV     A, R7           ; Desetiny a setiny stupne
                ANL     A, #0F0h        ; Potrebuji jen desetiny stupne
                ADD     A, B
                SWAP    A
                ACALL   ZobrAL          ; Zobrazi stupne a desetiny stupne
                ORL     DispBuff+2, #80h; Desetinna tecka
                SJMP    ZobrTmpE

ZobrTmpP:                               ; Zobraz Teplotu
                MOV     A, R6
                ACALL   ZobrAH          ; Zobrazi stupne
                MOV     A, R6           ; Test nevyznamne nuly
                ANL     A, #0F0h
                JNZ     ZobrTmpR
                MOV     DispBuff+0, #00h
ZobrTmpR:       MOV     A, R7
                ACALL   ZobrAL          ; Zobrazi desetiny a setiny stupne
                ORL     DispBuff+1, #80h; Desetinna tecka
ZobrTmpE:
                POP     B
                POP     DPH
                POP     DPL
                AJMP    ZobrLED

DPdiv10:                             ; Vydeli DPTR deseti, zbytek ulozi do A
                PUSH    B
                MOV     A, DPH
                MOV     B, #10
                DIV     AB           ; A:Vysledek, B:Zbytek
                MOV     DPH, A       ; MSB vyresen

                MOV     A, DPL
                ANL     A, #0F0h     ; Nyni Zbytek + Horni octet z LSB
                ADD     A, B         ; B < 10
                SWAP    A            ; V A Zbytek + Horni octet
                MOV     B, #10
                DIV     AB        ; V Dolnim octetu A Horni octet LSB vysledku
                SWAP    A
                XCH     A, DPL       ; Mezivysledek do DPL, do A LSB

                ANL     A, #00Fh     ; Nyni Dolni octet LSB
                SWAP    A            ; Platna data B jsou take v Dolnim octetu
                ADD     A, B         ; Odpovida XCH A,B; SWAP A; ADD A,B
                SWAP    A            ; Prohod octety do spravneho poradi, tj.
                MOV     B, #10       ; Zbytek z B v Hornim + Dolni octet LSB
                DIV     AB
                ADD     A, DPL       ; Pricti mezivysledek
                MOV     DPL, A
                MOV     A, B         ; V B zbytek, presun jej do A
                POP     B
                RET

; ============================================================================

CompTMP:                             ; Porovna TempH,L s Max a Min
                ACALL   WDtick
                PUSH    Acc
                MOV     A, TempH
                CJNE    A, #InvalTMP, CompRe1
                MOV     ReStatus, #00
                SJMP    UpDateRe2       ; InvalTMP -> vypni obe Rele

CompRe1:                                ; Porovnej Re1
                MOV     A, TempH
                CLR     C
                SUBB    A, Re1MaxH      ; (Re1MaxH)
                JC      PorovMin1       ; TempH < Re1MaxH -> skoc
                JNZ     VypniRe1        ; <> 0 -> TempH > Re1MaxH
                MOV     A, TempL        ; (TempL) TempH = Re1MaxH
                SUBB    A, Re1MaxL      ; (Re1MaxL)
                JC      PorovMin1       ; TempL < Re1MaxL -> skoc
                JZ      CompRe2         ; TempL = Re1MaxL -> skoc
VypniRe1:
                ANL     ReStatus, #0FEh ; Temp > Re1Max -> Vypni Re1
                MOV     A, FunkceRe1    ; Uprav stav rele podle funkce
                XRL     ReStatus, A     ; = XOR ReStatus, FunkceRe
                SJMP    CompRe2

PorovMin1:                              ; Test na zapnuti Re1
                MOV     A, TempH        ; (TempH)
                CLR     C
                SUBB    A, Re1MinH      ; (Re1MinH)
                JC      ZapniRe1        ; TempH < Re1MinH -> skoc
                JNZ     CompRe2         ; <> 0 -> TempH > Re1MinH
                MOV     A, TempL        ; (TempL) TempH = Re1MinH
                SUBB    A, Re1MinL      ; (Re1MinL)
                JNC     CompRe2         ; TempL >= Re1MinL -> skoc
ZapniRe1:
                ORL     ReStatus, #01h  ; Temp < Re1Min -> Zapni Re1
                MOV     A, FunkceRe1    ; Uprav stav rele podle funkce
                XRL     ReStatus, A     ; = XOR ReStatus, FunkceRe

CompRe2:                                ; a nyni porovnej Re2
                MOV     A, TempH        ; (TempH)
                CLR     C
                SUBB    A, Re2MaxH      ; (Re2MaxH)
                JC      PorovMin2       ; TempH < Re2MaxH -> skoc
                JNZ     VypniRe2        ; <> 0 -> TempH > Re2MaxH
                MOV     A, TempL        ; (TempL) TempH = Re2MaxH
                SUBB    A, Re2MaxL      ; (Re1MaxL)
                JC      PorovMin2       ; TempL < Re2MaxL -> skoc
                JZ      UpDateRe2       ; TempL = Re2MaxL -> skoc
VypniRe2:  
                ANL     ReStatus, #0FDh ; Temp > Re2Max -> Vypni Re2
                MOV     A, FunkceRe2    ; Uprav stav rele podle funkce
                XRL     ReStatus, A     ; = XOR ReStatus, FunkceRe
                SJMP    UpDateRe2

PorovMin2:                              ; Test na zapnuti Re2
                MOV     A, TempH        ; (TempH)
                CLR     C
                SUBB    A, Re2MinH      ; (Re2MinH)
                JC      ZapniRe2        ; TempH < Re2MinH -> skoc
                JNZ     UpDateRe2       ; <> 0 -> TempH > Re2MinH
                MOV     A, TempL        ; (TempL) TempH = Re2MinH
                SUBB    A, Re2MinL      ; (Re2MinL)
                JNC     UpDateRe2       ; TempL >= Re2MinL -> skoc
ZapniRe2: 
                ORL     ReStatus, #02h  ; Temp < Re2Min -> Zapni Re2
                MOV     A, FunkceRe2    ; Uprav stav rele podle funkce
                XRL     ReStatus, A     ; = XOR ReStatus, FunkceRe
                SJMP    UpDateRe2

UpDateRe:       PUSH    Acc             ; Zapne/Vypne Rele podle ReStatusu
UpDateRe2:      MOV     A, ReStatus
                CPL     A               ; 0 na vystupu zapne Rele
                RRC     A               ; Stav Re1 do C
                MOV     P3.5, C
                RRC     A               ; Stav Re2 do C
                MOV     P3.4, C

                ANL     LEDBuff, #0F8h  ; Jeste uprav LED diody
                MOV     A, ReStatus
                ANL     A, #03h         ; Pro jistotu
                ORL     LEDBuff, A

                JB      P3.2, UpDateReE ; Precti stav OPTO vstupu
                ORL     LEDBuff, #04    ; 0 = sepnuto -> rozsvit LED
UpDateReE:
                POP     Acc
                RET

; ********************************************************  Obsluha Klavesnice

TestKBD:
                CLR     A
                XCH     A, KBD          ; KBD = 0, A = KBD
                XCH     A, KBDPom       ; KBDpom = OldKBD

                JNB     P1.5, TestTL2   ; TL1
                ORL     KBD, #01h
TestTL2:
                JNB     P3.3, TestKbdEnd; TL2
                ORL     KBD, #02h
TestKbdEnd:
;                MOV     A, KBD
                RET

; ***************************************************************  Obsluha LED

InitLED:                                ; Inicializace LED Displaye

ClrLED:                                 ; Provede Reset = Vymazani LED
                MOV     R0, #LEDBuff
                MOV     B, #5
                CLR     A
ClrLED1:
                MOV     @R0, A
                INC     R0
                DJNZ    B, ClrLED1

ZobrLED:                                ; Zobrazi obsah LED Bufferu
                ACALL   SegmKonv        ; Prepocet segmentu mezi
                                        ;   LEDBuff a PomBuff
                CLR     P1.6            ; Hodiny M5451 do 0 - pro jistotu
                SETB    C
                ACALL   PosliC          ; Uvodni zapisovaci impuls

                MOV     A, LEDBuff      ; Samostatne LED
                MOV     R1, #3
ZobrLED1:
                RRC     A               ; Do C nejnizsi bit Acc
                ACALL   PosliC
                DJNZ    R1, ZobrLED1

                MOV     R0, #PomBuff
                MOV     B, #4           ; Celkem 4 cislice
ZobrLED2:
                MOV     A, @R0
                MOV     R1, #8          ; 8 LED segmentu
ZobrLED3:
                RRC     A               ; Do C nejnizsi bit Acc
                ACALL   PosliC
                DJNZ    R1, ZobrLED3

                INC     R0
                DJNZ    B, ZobrLED2     ; Dalsi cislicovka

                RET

PosliC:                                 ; Zapise obsah C na vstup M5451
                MOV     P1.7, C         ; Data M5451
                NOP
                                        ; Zapisovaci Impuls
                SETB    P1.6            ; Hodiny M5451
                NOP                     ; Delka Impulsu min. 950 ns
;                ACALL   Wait40
                CLR     P1.6
                RET

SegmKonv:                               ; Provede prepocet segmentu
                MOV     R1, #PomBuff    ; R1 - Cil

                MOV     R0, #4          ; Smaz PomBuff
                CLR     A
SKonv1:         MOV     @R1, A
                INC     R1
                DJNZ    R0, SKonv1

                MOV     DPTR, #LEDconv  ; Konverzni tabulka
                MOV     R0, #DispBuff   ; R0 - Zdroj
                MOV     B, #4
SKonv2:
                MOV     R2, #8
                MOV     A, @R0
                MOV     R4, A
SKonv3:
                MOV     A, R4
                CLR     C
                RRC     A
                MOV     R4, A 
                JNC     SKonv5          ; 0 - Zhasnuto, skoc

                CLR     A
                MOVC    A, @A+DPTR
                SWAP    A               ; Horni Nibble = Cislo Bytu
                ANL     A, #03h         ; 0 .. 3 Byte
                ADD     A, #PomBuff
                MOV     R1, A           ; R1 - Cil

                CLR     A
                MOVC    A, @A+DPTR
                ANL     A, #007h        ; Dolni Nibble = Cislo Bitu

                MOV     R3, A
                INC     R3              ; Pocet rotaci, 0 = 8
                MOV     A, #080h
SKonv4:                                 ; Odrotovani bitu na spravne misto
                RL      A
                DJNZ    R3, Skonv4
                ORL     A, @R1          ; ORuj se stavajicim obsahem PomBuff
                MOV     @R1, A          ; Uloz zpet do PomBuff

SKonv5:
                INC     DPTR            ; Dalsi radek tabulky
                DJNZ    R2, SKonv3

                INC     R0
                DJNZ    B, SKonv2

                RET

; ********************************************************  Zobrazovaci rutiny

ZobrAH:                                 ; Vypise obsah A v HEX do DispBuff
                PUSH    DPL             ; na pozici XX..
                PUSH    DPH
                MOV     DPTR, #Table7seg
                PUSH    Acc
                SWAP    A
                ANL     A, #0Fh
                MOVC    A, @A+DPTR
                MOV     DispBuff+0, A
                POP     Acc
                ANL     A, #0Fh
                MOVC    A, @A+DPTR
                MOV     DispBuff+1, A
                POP     DPH
                POP     DPL
                RET

ZobrAL:                                 ; Vypise obsah A v HEX do DispBuff
                PUSH    DPL             ; na pozici ..XX
                PUSH    DPH
                MOV     DPTR, #Table7seg
                PUSH    Acc
                SWAP    A
                ANL     A, #0Fh
                MOVC    A, @A+DPTR
                MOV     DispBuff+2, A
                POP     Acc
                ANL     A, #0Fh
                MOVC    A, @A+DPTR
                MOV     DispBuff+3, A
                POP     DPH
                POP     DPL
                RET

ZobrVer:                                ; Vypsani verze programu
                MOV     DispBuff+0, #3Eh
                MOV     DispBuff+1, #78h
                MOV     A, #MainVer
                SWAP    A
                ADD     A, #SubVer
                ACALL   ZobrAL           ; Priprav MainVer+SubVer do DispBuff
                ORL     DispBuff+2, #80h ; Desetinna tecka
                AJMP    ZobrLED

; ***************************************************  Obsluha 1-Wire sbernice

ReadTMP:                                ; Precte teplotu a ulozi do TempH,L
                PUSH    B               ; Nici mj. R2, R3, R4, R5 a R7
                ACALL   Read_SPad       ; Spolecne pro DS1820 i DS1822
                JB      F0, ReadTMPe    ; Nastaven F0 = doslo k chybe (CRC)
                ACALL   Prev1820        ; Preved teplotu pro DS1820
                SJMP    ReadTMPc
ReadTMPe:
                MOV     TempH, #InvalTMP; Ulozi misto chybne hodnoty InvalTMP
                MOV     TempL, #InvalTMP
ReadTMPc:
                POP     B
                RET

Read_SPad:                              ; Nacte Scratch Pad do R2-R5,CRC do R7
                PUSH    B               ; pocitadlo neuspesnych cteni
                CLR     EA              ; Zakaz preruseni (casovani 1-Wire)
                MOV     R7, #00         ; Vynuluj pocatecni hodnotu pro CRC
                MOV     B, #3           ; Max. 3 pokusy
ReadSPad:
                ACALL   WDtick          ; Watchdog
                ACALL   OneW_Reset
                MOV     A, #0CCh        ; Skip ROM
                ACALL   OneW_Tx
                MOV     A, #0BEh        ; Read Scratch Pad
                ACALL   OneW_Tx
                ACALL   OneW_Rx         ; R2 - LSB
                MOV     R2, A
                ACALL   CalcCRC
                ACALL   OneW_Rx         ; R3 - MSB - Znamenko
                MOV     R3, A
                ACALL   CalcCRC
                ACALL   OneW_Rx         ; TH
                ACALL   CalcCRC
                ACALL   OneW_Rx         ; TL
                ACALL   CalcCRC
                ACALL   WDtick
                ACALL   OneW_Rx         ; Reserved / Configuration
                ACALL   CalcCRC
                ACALL   OneW_Rx         ; Reserved / Reserved
                ACALL   CalcCRC
                ACALL   OneW_Rx         ; R4 - Count Remain / Reserved
                MOV     R4, A
                ACALL   CalcCRC
                ACALL   OneW_Rx         ; R5 - Count Per C / Reserved
                MOV     R5, A
                ACALL   CalcCRC
                ACALL   OneW_Rx         ; CRC
                ACALL   CalcCRC         ; CRC tam zapocti taky -> 0 = O.K.
                MOV     A, R7
                JZ      ReadSPOK        ; Je-li vse v poradku, je tam nula
                DJNZ    B, ReadSPad
                SETB    F0              ; Opakovana chyba CRC
                SJMP    ReadSPEnd
ReadSPOK:       CLR     F0              ; O.K. -> F0 = 0
ReadSPEnd:      SETB    EA              ; Povoli preruseni (casovani 1-Wire)
                POP     B
                AJMP    WDtick          ; Watchdog

Start_Conv:                             ; Zada prikaz pro start Konverze
                CLR     EA              ; Zakaz preruseni (casovani 1-Wire)
                ACALL   OneW_Reset
                MOV     A, #0CCh        ; Skip ROM
                ACALL   OneW_Tx
                MOV     A, #044h        ; Convert
                ACALL   OneW_Tx
DQ_PullUp:                              ; Vsechny okruhy najednou
                SETB    P1.3            ; "1"
                CLR     P1.4            ; Enable 125
                RET

CalcCRC:                                ; Vypocte CRC z obsahu A
                PUSH    Acc
                PUSH    B
                PUSH    Acc             ; Ulozeni Vypocitavaneho Byte
                MOV     B, #8           ; 8 bitu = 8 cyklu
CalcCRC1:
                XRL     A, R7           ; v R7 predchozi mezivysledek CRC
                RRC     A               ; XOR vstupniho bitu do C
                MOV     A, R7           ; predchozi vysledek CRC do A
                JNC     CalcCRC2        ; A xor 0 = A, nemeni se -> preskoc
                XRL     A, #18h         ; 18 vyplyva z Polynomu
CalcCRC2:
                RRC     A               ; Odrotuj, novy vstupni bit v C
                MOV     R7, A           ; Uloz novou hodnotu mezivysledku CRC
                POP     Acc             ; Obnova Vypocitavaneho Byte
                RR      A               ; Posun bity ve Vypocitavanem Byte
                PUSH    Acc             ; a uloz zpet do zasobniku
                DJNZ    B, CalcCRC1     ; cele opakuj pro vsech 8 bitu
                POP     Acc
                POP     B
                POP     Acc
                RET

OneW_Tx:                                ; Zapise Byte na 1-Wire sbernici
                PUSH    B
                MOV     B, #8           ; 8 bitu
OW_TxLoop:
                RRC     A
                ACALL   OneW_Tx1        ; Vysle bit v C na 1-Wire sbernici
                DJNZ    B, OW_TxLoop

                POP     B
                RET

OneW_Tx1:                               ; Zapise C (1 Bit) na 1-Wire sbernici
                PUSH    Acc
                JNC     OW_Tx0          ; Skoc podle bitu C
                ACALL   DQ_01           ; Zapis 0 a ihned 1
                SJMP    OW_TxWait
OW_Tx0:
                ACALL   DQ_0            ; Zapis 0 a potom jako data opet 0
OW_TxWait:      MOV     A, #5           ; Vysilaci cyklus je 60 uS
                ACALL   A10Wait
                ACALL   DQ_1            ; Min. 1 uS v 1
                POP     Acc
                RET

OneW_Rx:                                ; Precte Byte z 1-Wire sbernice
                PUSH    B
                MOV     B, #8           ; 8 bitu
OW_RxLoop:
                ACALL   OneW_Rx1        ; Do C Bit z 1-Wire sbernice
                RRC     A               ; A neni nutne predtim mazat
                DJNZ    B, OW_RxLoop
                POP     B
                RET

OneW_Rx1:                               ; Precte 1 Bit z 1-Wire sbernice
                PUSH    Acc

                ACALL   DQ_01           ; Nastavi DQ na 0 a ihned na 1
                MOV     A, #5           ; Nyni cekej na platny Bit
                DJNZ    Acc, $          ; Cekej celkem 13 Cyklu, vcetne RET
                MOV     C, P1.0         ; Precti Bit

                MOV     A, #5           ; Neni nutne uchovavat C, protoze 
                ACALL   A10Wait         ; A10Wait nenici PSW
                POP     Acc
                RET

OneW_Reset:                             ; Provede RESET 1-Wire sbernice
                PUSH    Acc
                ACALL   DQ_0
                MOV     A, #48+1        ; tRSTL - min. 480 nS v "0"
                ACALL   A10Wait
                ACALL   DQ_1
                MOV     A, #7           ; Min. tPDHIGH + Min. tPDLOW
                ACALL   A10Wait
                                        ; Zde by bylo Cteni Presence Pulse
                MOV     A, #48-7+1      ; tRSTH - min. 480 nS v "1"
                ACALL   A10Wait
                POP     Acc
                RET

DQ_0:                                   ; Shodi DQ na 0 
                CLR     P1.3            ; "0"
                CLR     P1.4            ; Enable 125 = CLR bit
                RET

DQ_1:                                   ; Nastavi DQ na 1
                SETB    P1.4            ; Disable 125 = SETB bit
                RET

DQ_01:                                  ; Nastavi DQ na 0 a ihned na 1
                SETB    P1.4            ; Disable 125 = "1" - pro jistotu
                CLR     P1.3            ; priprav "0"
                CLR     P1.4            ; Enable 125 = "0"

                SETB    P1.4            ; Disable 125 = "1"
                RET

; ----------------------------------------------------------------------------

Prev1820:                        ; Prevede teplotu s max. presnosti pro DS1820
;
;                          PerC - Remain  
; TMP = TEMP_READ - 0.25 + -------------
;                              PerC
;
                MOV     A, R3           ; MSB
                RRC     A               ; v C je znamenko
                MOV     A, R2           ; LSB
                RRC     A               ; Odstran Pulstupne
                ADD     A, #50          ; Posunuta nula - 50 stupnu

                MOV     B, #10          ; Preved na setiny stupnu Celsia
                MUL     AB              ; Vynasob 100x a uloz do DP
                MOV     DPH, B          ; A:LSB, B:MSB
                MOV     B, #10          ; v A je LSB
                MUL     AB
                MOV     DPL, A          ; Vysledne LSB
                PUSH    B               ; Uloz prenos do vyssiho radu
                MOV     A, DPH
                MOV     B, #10
                MUL     AB
                POP     B               ; MSB zahod,do B prenos z nizsiho radu
                ADD     A, B            ; Pricti prenos z nizsiho radu
                MOV     DPH, A          ; TEMP_READ v DP

                CLR     C               ; Odecti 0.25 stupne
                MOV     A, DPL
                SUBB    A, #25
                MOV     DPL, A
                JNC     PrevedT0
                DEC     DPH             ; Byl prenos, odecti 1 z vyssiho radu

PrevedT0:
                MOV     A, R4           ; Remain; Je-li 0 => Podil = 1 => 0,99
                JZ      Preved255
                MOV     A, R5           ; PerC
                MOV     B, A            ; B := PerC
                CLR     C
                SUBB    A, R4           ; Remain; A := PerC - Remain
                ACALL   A_Div_B         ; A := (A / B)
                SJMP    PrevedSetiny
Preved255:
                MOV     A, #255
PrevedSetiny:                           ; v A nyni stupne v 1/256
                MOV     B, #100       ; preved je do 1/100 vynasobenim 100/256
                MUL     AB
                MOV     A, B            ; Vezmu-li MSB -> vydelil jsem 256
                ADD     A, DPL          ; Pricti k DP
                MOV     DPL, A
                JNC     BezPrenosu
                INC     DPH             ; Byl prenos -> Zvys stupne
BezPrenosu:                             ; Uloz DP do TempH,L 
                MOV     TempH, DPH      ; (TempH)
                MOV     TempL, DPL      ; (TempL)
                RET

A_Div_B:                                ; A deleno B v deset. HEX, A < B
                                        ; Nici R4, R5 a R7           
                MOV     R4, #00         ; Vysledek
                MOV     R5, B           ; Delitel - Pomocne ulozeni
                MOV     R7, #08         ; Citac - 8 bitu
A_DivLoop:      RL      A               ; Vynasob 2
                MOV     B, R5
                DIV     AB
                JZ      A_Div1          ; Je to delitelne ?
                SETB    C
A_Div1:         MOV     A, R4
                RLC     A               ; Pripoj k vysledku
                MOV     R4, A
                MOV     A, B            ; Zbytek se pokus dal delit
                DJNZ    R7, A_DivLoop   ; Opakuj 8x

                MOV     A, R4
                RET

; *******************************************************************  Prevody

PrevedHEX:                              ; Prevede String @DPTR na HEX v R2,R3
                CLR     A
                MOVC    A, @A+DPTR
                PUSH    Acc             ; Uloz znamenko
                INC     DPTR

                CLR     A
                MOVC    A, @A+DPTR      ; Desitky stupnu
                ANL     A, #0Fh         ; ASCII -> Cifra
                SWAP    A
                MOV     R2, A
                INC     DPTR
                CLR     A
                MOVC    A, @A+DPTR      ; Jednotky stupnu
                ANL     A, #0Fh         ; ASCII -> Cifra
                ANL     A, #0Fh
                ADD     A, R2
                ACALL   BCD_HEX         ; Preved stupne z BCD na HEX
                MOV     R2, A
                INC     DPTR

                INC     DPTR            ; Desetinna tecka

                CLR     A
                MOVC    A, @A+DPTR      ; Desetiny stupne
                ANL     A, #0Fh         ; ASCII -> Cifra
                SWAP    A
                MOV     R3, A
                INC     DPTR
                CLR     A
                MOVC    A, @A+DPTR      ; Setiny stupne
                ANL     A, #0Fh         ; ASCII -> Cifra
                ADD     A, R3
                ACALL   BCD_HEX         ; Preved desetiny stupne z BCD na HEX
                MOV     R3, A

                POP     Acc             ; Obnov znamenko a podle nej zpracuj
                CJNE    A, #'-', PrevedP
PrevedM:
                MOV     A, R2
                MOV     B, #100         ; Pri prevodu do setin stupne vynasob
                MUL     AB
                ADD     A, R3           ; v A je LSB, pricti k nemu setiny
                MOV     R3, A
                MOV     A, B            ; v B je MSB
                ADDC    A, #0           ; pripocti prenos
                MOV     R2, A

                CPL     A
                MOV     R2, A
                MOV     A, R3
                CPL     A
                ADD     A, #89h         ; 5000 + 1
                MOV     R3, A
                MOV     A, R2
                ADDC    A, #13h
                MOV     R2, A
                RET

PrevedP:
                MOV     A, R2
                ADD     A, #50          ; Pricti posunutou nulu = 50 stupnu
                MOV     B, #100         ; Pri prevodu do setin stupne vynasob
                MUL     AB
                ADD     A, R3           ; v A je LSB, pricti k nemu setiny
                MOV     R3, A
                MOV     A, B            ; v B je MSB
                ADDC    A, #0           ; pripocti prenos
                MOV     R2, A
                RET

BCD_HEX:                                ; Prevede BCD cislo do HEX
                PUSH    B
                PUSH    Acc
                ANL     A, #0Fh         ; jednotky do R0
                MOV     B, A
                POP     Acc
                ANL     A, #0F0h
                SWAP    A               ; desitky
                PUSH    B
                MOV     B, #10
                MUL     AB              ; Nizsi v A
                POP     B
                ADD     A, B            ; Pricti jednotky
                POP     B
                RET

; ********************************************************************  Cekani

A10Wait:                                ; Ceka A * 10 uS
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                DJNZ    Acc, A10Wait
                RET

Wait40:                                 ; Ceka cca 40 mikrosekund
                PUSH    Acc
                MOV     A, #14
                DJNZ    Acc, $
                POP     Acc
                RET

DelayA:                                 ; Ceka A * Delay = A milisekund
                ACALL   Delay
                ACALL   WDtick          ; Watchdog
                DJNZ    Acc, DelayA
                RET

Delay:				        ; Ceka asi 1 ms / 11.0592 MHz
		PUSH	PSW             ; Celkem 921 vcetne CALL a RET
                PUSH    Acc             ;   7 + 227 * 4 + 6
		MOV	A, #227
DelayLoop:	NOP
		NOP
		DJNZ	Acc, DelayLoop
		POP	Acc
		POP	PSW
		RET

CekejKonv:                              ; Cekani na dokonceni konverze
                CLR     A
                ACALL   DelayA          ; Pomocne cekani
                ACALL   DelayA
                ACALL   DelayA
                RET

WDtick:                                 ; Watchdog MB3773 se resetuje po 10 ms
                CPL     P1.7            ; Data M5451 - Buzeni Watchdogu
                RET

; *****************************************************************  Konstanty

Table7seg:      DB      3Fh, 06h, 5Bh, 4Fh, 66h, 6Dh, 7Dh, 07h
                DB      7Fh, 6Fh, 77h, 7Ch, 39h, 5Eh, 79h, 71h

LEDconv:        DB      22h, 23h, 17h, 15h, 16h, 20h, 21h, 14h
                DB      25h, 26h, 10h, 12h, 13h, 24h, 11h, 07h
                DB      04h, 03h, 31h, 30h, 27h, 06h, 05h, 32h
                DB      01h, 00h, 36h, 34h, 33h, 02h, 35h, 37h

FceRe1:         DB      'T'
MaxTEMP1:       DB      ' 19,75'
MinTEMP1:       DB      ' 18,75'
FceRe2:         DB      'T'
MaxTEMP2:       DB      ' 08,00'
MinTEMP2:       DB      ' 04,00'

                END
